// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
//#include <GL/glu.h>

// .h subor
#include "mDataFile.h"

// konstruktor *************************************************************
mDataFile::mDataFile()
{
 datafile=ff;

 gldata_count=0;
 gldata=NULL;

 texcount=0;
 for (a=0;a<64;a++) {
  texname[a]=NULL;
 }
}

// destruktor **************************************************************
mDataFile::~mDataFile()
{
 CloseDataFile();
}

// otvorenie suboru ********************************************************
void mDataFile::OpenDataFile(char *fname)
{
 strcpy(datafile,fname); // jedna sa iba o urcenie mena suboru
}

// nacitanie udajov ********************************************************
GLfloat *mDataFile::ReadData(void)
{
 CloseDataFile(); // nove nacitanie suboru, zmazu sa predosle udaje

 df=fopen(datafile,"r"); // otvorenie suboru
 if (!df) {
  fprintf(stderr,"Chyba pri otvarani suboru: %s\n",datafile); return(NULL);
 }

 // pozn. 'x' urci koniec definicie textur a neskor tiez koniec suboru
 // preskocenie definicie textur
 while (!feof(df)) {
  fscanf(df,"%s",fstring); if (!strcmp(fstring,"x")) break;
 }

 // zistenie celkoveho poctu trojuholnikov ulozenych v datovom subore
 gldata_count=0;
 while (!feof(df)) {
  fscanf(df,"%s",fstring); if (!strcmp(fstring,"x")) break;

  for (a=0;a<15;a++) fscanf(df,"%f",&ffloat);
  gldata_count++;
 }
 
 rewind(df); // naspat na zaciatok suboru
 
 // nacitanie textur
 a=0;
 while (!feof(df)) {
  fscanf(df,"%s",fstring); if (!strcmp(fstring,"x")) break;
  texname[a]=(char *) malloc(32*sizeof(char));
  if (texname[a]==NULL) {
   fclose(df);
   fprintf(stderr,"Error allocating memory for texname!\n"); return(NULL);
  }
  fscanf(df,"%s",fstring);
  strcpy(texname[a],fstring);
  a++;
 }
 texcount=a;
 
 // priprava miesta pre udaje jednotlivych trojuholnikov
 gldata=(GLfloat *) malloc(gldata_count*16*sizeof(GLfloat));
 if (gldata==NULL) {
  fclose(df);
  fprintf(stderr,"Error allocating memory for gldata!\n"); return(NULL);
 }

 // nacitanie udajov jednotlivych trojuholnikov
 for (a=0;a<(gldata_count*16);a+=16) {
  for (b=0;b<16;b++) fscanf(df,"%f",(gldata+a+b));
 }
 
 fclose(df); // zatvorenie suboru
 
 return(gldata); // vratenie zoznamu udajov o trojuholnikoch
}

// zatvorenie suboru *******************************************************
void mDataFile::CloseDataFile(void)
{
 if (gldata!=NULL) {
  free(gldata); gldata=NULL;
 }
 for (a=0;a<64;a++) {
  if (texname[a]!=NULL) free(texname[a]); texname[a]=NULL;
 }
}
