// hlavickove subory *******************************************************
// systemove funkcie
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mOGL.h"

// konstruktor *************************************************************
mOGL::mOGL()
{
 StartInfoPos=10.0f; // pozicia vypisu 1. textu pocas startu aplikacie
	
 t_a=0; t_b=0; // pomocne premenne
	
 normals_onoff=0;  // normaly sa nekreslia
 help_onoff=0;     // napoveda sa nevypisuje
 lighting_onoff=1; // osvetlenie zapnute
 fog_onoff=1;      // hmla vypnuta

 rot_x=0.0f; rot_y=0.0f; pos_y=4.0f; add_y=0.0025f;

 // koeficienty rovnice orezavacej roviny
 plane_equ[0]=0.0f; plane_equ[1]=-1.0f; plane_equ[2]=0.0f; plane_equ[3]=0.0f;
}

// destruktor **************************************************************
mOGL::~mOGL()
{

}

// vypis info pocas startu aplikacie ***************************************
void mOGL::PrintStartInfo(char *infotext)
{
 ogl_Text.OpenDrawString();
 ogl_Text.SetTextColor(0.0f,0.0f,0.0f);
 sprintf(ogl_Text.mybuf,infotext);
 ogl_Text.DrawString(10.0f,StartInfoPos);
 ogl_Text.CloseDrawString();

 // vymena zobrazovacich zasobnikov, zobrazenie sceny
 SDL_GL_SwapBuffers();

 // dalsi text bude vypisany na novu poziciu
 StartInfoPos+=20.0f;

 // pauza aby bol text aspon chvilku viditelny
 SDL_Delay(300);
}

// inicializacia OpenGL - nastavenie parametrov pre tvorbu OpenGL sceny ****
bool mOGL::gl_initialize(void)
{
 // definicia premennych ***************************************************
 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych materialov
  ogl_Material[t_a].amb[0]=1.0f; ogl_Material[t_a].amb[1]=1.0f;
  ogl_Material[t_a].amb[2]=1.0f; ogl_Material[t_a].amb[3]=1.0f;
  ogl_Material[t_a].dif[0]=0.6f; ogl_Material[t_a].dif[1]=0.6f;
  ogl_Material[t_a].dif[2]=0.6f; ogl_Material[t_a].dif[3]=1.0f;
  ogl_Material[t_a].spe[0]=1.0f; ogl_Material[t_a].spe[1]=1.0f;
  ogl_Material[t_a].spe[2]=1.0f; ogl_Material[t_a].spe[3]=1.0f;
  ogl_Material[t_a].amb_dif[0]=0.25f; ogl_Material[t_a].amb_dif[1]=0.25f;
  ogl_Material[t_a].amb_dif[2]=0.25f; ogl_Material[t_a].amb_dif[3]=1.0f;
  ogl_Material[t_a].emi[0]=0.0f; ogl_Material[t_a].emi[1]=0.0f;
  ogl_Material[t_a].emi[2]=0.0f; ogl_Material[t_a].emi[3]=1.0f;
  ogl_Material[t_a].shi=0.0f;
  ogl_Material[t_a].transp=0.0f;
  ogl_Material[t_a].sillum[0]=0.0f; ogl_Material[t_a].sillum[1]=0.0f;
  ogl_Material[t_a].sillum[2]=0.0f; ogl_Material[t_a].sillum[3]=1.0f;
 }

 for (t_a=0;t_a<8;t_a++) { // nastavenie 8-mich vseobecnych svetiel
  ogl_Light[t_a].amb[0]=0.25f; ogl_Light[t_a].amb[1]=0.25f;
  ogl_Light[t_a].amb[2]=0.25f; ogl_Light[t_a].amb[3]=1.0f;
  ogl_Light[t_a].dif[0]=0.5f; ogl_Light[t_a].dif[1]=0.5f;
  ogl_Light[t_a].dif[2]=0.5f; ogl_Light[t_a].dif[3]=1.0f;
  ogl_Light[t_a].spe[0]=0.75f; ogl_Light[t_a].spe[1]=0.75f;
  ogl_Light[t_a].spe[2]=0.75f; ogl_Light[t_a].spe[3]=1.0f;
  ogl_Light[t_a].pos[0]=-2.0f; ogl_Light[t_a].pos[1]=3.0f;
  ogl_Light[t_a].pos[2]=-22.0f; ogl_Light[t_a].pos[3]=1.0f;
  // pos[3]=1.0f - vsesmerove svetlo, 0.0f - smerove svetlo
  ogl_Light[t_a].spot[0]=0.0f;
  ogl_Light[t_a].spot[1]=0.0f;
  ogl_Light[t_a].spot[2]=-1.0f;
 }

 // STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ STAVOVY STROJ --

 // nastavenie OpenGL renderovacich parametrov *****************************
 //glClearColor(0.50f,0.60f,0.75f,0.5f); // zasobnik farieb bude vymazavany modrou farbou
 glClearColor(0.0f,0.0f,0.0f,0.5f); // zasobnik farieb bude vymazavany ciernou farbou
 glClearDepth(1.0f);                   // zasobnik hlbky bude vymazavany nastavenim na 1.0f
 glClearStencil(0);                    // zasobnik stencil bude vymazavany nastavenim na 0

 // nastavenie parametrov 1. svetla
 glLightfv(GL_LIGHT0,GL_AMBIENT,ogl_Light[0].amb);
 glLightfv(GL_LIGHT0,GL_DIFFUSE,ogl_Light[0].dif);
 glLightfv(GL_LIGHT0,GL_SPECULAR,ogl_Light[0].spe);
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);
 glEnable(GL_LIGHT0);
 if (lighting_onoff) glEnable(GL_LIGHTING);
 else glDisable(GL_LIGHTING);

 glDepthFunc(GL_LEQUAL);  // typ porovnavacej funkcie pre urcenie z-vzdialenosti
 glEnable(GL_DEPTH_TEST); // zapnutie testovania hlbky

 glDisable(GL_CULL_FACE); // nastavenie poradia, v ktorom budu definovane body objektu
 glFrontFace(GL_CCW);     // reprezentovat privratene resp. odvratene plochy,
 glCullFace(GL_BACK);     // CCW - proti smeru hod. ruciciek, CW - v smere hod. ruciciek
 glEnable(GL_CULL_FACE);  // odvratene plochy sa nebudu spracovavat

 // vseobecny material objektov
 glMaterialfv(GL_FRONT,GL_AMBIENT_AND_DIFFUSE,ogl_Material[0].amb_dif);

 // pre Gourandove svetelne vypocty bude pouzity material priradeny objektu,
 // ktory bude ale stale ovplyvneny farbou zadavanou prikazom glColor
 glEnable(GL_COLOR_MATERIAL);
 // farba bude mat vplyv iba na 'diffuse' komponent materialu
 glColorMaterial(GL_FRONT,GL_DIFFUSE);
 // svetlo sa pocita len pre privratene strany
 glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
 // svetelne vypocty su lokalne
 glLightModelf(GL_LIGHT_MODEL_LOCAL_VIEWER,GL_TRUE);
 // zapnutie gourand-jemneho tienovania
 glShadeModel(GL_SMOOTH);
 // osvetlenie textur alias modulate
 //glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);
 // realnejsie perspektivne vypocty a korekcie
 glHint(GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST);

 ogl_FogColor[0]=0.0f; ogl_FogColor[1]=0.0f;
 ogl_FogColor[2]=0.0f; ogl_FogColor[3]=1.0f;
 glFogi(GL_FOG_MODE,GL_EXP2);        // typ hmly
 glFogfv(GL_FOG_COLOR,ogl_FogColor); // farba hmly
 glFogf(GL_FOG_DENSITY,0.05f);       // hustota hmly
 glHint(GL_FOG_HINT,GL_DONT_CARE);   // dalsie nastavenia
 glFogf(GL_FOG_START,2000.0f);       // pociatok viditelnosti hmly
 glFogf(GL_FOG_END,4000.0f);         // vzdialenost max. hmly
 if (fog_onoff) glEnable(GL_FOG);    // povolenie hmly

 // zapnutie poli vrcholov, normal, koordinatov textur
 //glEnableClientState(GL_VERTEX_ARRAY);
 //glEnableClientState(GL_NORMAL_ARRAY);
 //glEnableClientState(GL_TEXTURE_COORD_ARRAY);

 // antialiasing ciar alias smoothline
 //glEnable(GL_LINE_SMOOTH);
 //glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);

 // funkcia pre vypocet priesvitnosti
 //glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
 //glEnable(GL_BLEND); // zapnutie vypoctu priesvitnosti
 //glLineWidth(1.5f);

 // trojuholniky budu vyplnene
 glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);

 // zapnutie texturovania
 glEnable(GL_TEXTURE_2D);

 // nastavenie modu generovania koordinatov S (gulove mapovanie)
 //glTexGeni(GL_S,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);
 // nastavenie modu generovania koordinatov T (gulove mapovanie)
 //glTexGeni(GL_T,GL_TEXTURE_GEN_MODE,GL_SPHERE_MAP);

 // INICIALIZACIA SCENY INICIALIZACIA SCENY INICIALIZACIA SCENY ------------

 // vymazanie zasobnika farieb a hlbky
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);

 // inicializacia vypisovania OpenGL textu
 if (ogl_Text.text_initialize()) {
  fprintf(stderr,"Chyba inicializacie fontu!\n"); return(1);
 }

 PrintStartInfo("Nastavenie OpenGL stavoveho stroja...");
 PrintStartInfo("OK");

 /*
 PrintStartInfo("Vytvorenie skyboxu...");
 // nacitanie textur skyboxu
 if (ogl_Objects.obj_skybox_init("skybox")) {
  fprintf(stderr,"Chyba vytvorenia skyboxu!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Inicializacia OpenGL rozsireni...");
 if (ogl_Ext.Ext_init()) {
  fprintf(stderr,"Chyba inicilizacie OpenGL rozsireni!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Inicializacia vody...");
 if (ogl_Ext.water_init()) {
  fprintf(stderr,"Chyba inicilizacie vody!\n"); return(1);
 }
 PrintStartInfo("OK");
 */
 PrintStartInfo("Nacitanie textur...");
 // nacitanie textur
 strcpy(fname,"data/material/"); strcat(fname,"crate0"); strcat(fname,".bmp");
 if (ogl_Texture.LoadTexture(6,fname)) {
  fprintf(stderr,"Chyba nahratia textur!\n"); return(1);
 }
 PrintStartInfo("OK");
 /*
 PrintStartInfo("Inicializacia kvadratickych objektov...");
 if (ogl_Objects.obj_quadratic_init()) {
  fprintf(stderr,"Chyba inicializacie kvadratickych objektov!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Vytvorenie sosovkoveho efektu...");
 // nacitanie textur skyboxu
 if (ogl_Objects.obj_lensflare_init("lensflare")) {
  fprintf(stderr,"Chyba vytvorenia sosovkoveho efektu!\n"); return(1);
 }
 PrintStartInfo("OK");
 */
 PrintStartInfo("Vytvorenie zameriavacieho kriza...");
 // nacitanie obrazku zameriavacieho kriza
 strcpy(fname,"data/"); strcat(fname,"/"); strcat(fname,"crosshair0.bmp\0");
 if (ogl_Texture.LoadCrosshairTexture(fname)) {
  fprintf(stderr,"Chyba nacitania obrazku zameriavacieho kriza!\n"); return(1);
 }
 PrintStartInfo("OK");

 PrintStartInfo("Nacitanie udajov zo zdrojoveho subporu...");

 // urcenie mena zdrojoveho suboru
 strcpy(fname,"data/"); strcat(fname,"/"); strcat(fname,"room1.dat");
 ogl_DataFile.OpenDataFile(fname);
 
 // nacitanie udajov zo zdrojoveho suboru a priprava zoznamu trojuholnikov
 renew_data();
 
 PrintStartInfo("START");
 
 return(0);
}

// vykreslenie OpenGL sceny ************************************************
int mOGL::gl_draw(void)
{
 // detekcia kolizie kamery s trojuholnikmi
 // v pripade kolizie sa upravi poloha kamery
 if (m_Camera[0].collision_onoff==1) {
  // kolizia nenastala
  m_Camera[0].is_collision=0;

  // test so vsetkymi trojuholnikmi sceny
  m_FIRSTt=ogl_Triangle.GetFirstTriangle();
  m_NEXTt=m_FIRSTt;
  while (m_NEXTt!=NULL) {
   if (m_NEXTt->collision_tested==1) {
	// ak je potrebne trojuholnik testovat, zisti sa pripadna kolizia
    m_Camera[0].cam_collision(m_NEXTt->x1,m_NEXTt->y1,m_NEXTt->z1,
                              m_NEXTt->x2,m_NEXTt->y2,m_NEXTt->z2,
	                          m_NEXTt->x3,m_NEXTt->y3,m_NEXTt->z3,
                              m_NEXTt->tr_nx,m_NEXTt->tr_ny,m_NEXTt->tr_nz,
                              m_NEXTt->tr_cn1,m_NEXTt->tr_cn2, m_NEXTt->tr_cn3, m_NEXTt->tr_cn4,
                              m_NEXTt->tr_cn5,m_NEXTt->tr_cn6, m_NEXTt->tr_cn7, m_NEXTt->tr_cn8,
                              m_NEXTt->tr_cn9,m_NEXTt->tr_cn10,m_NEXTt->tr_cn11,m_NEXTt->tr_cn12);
   }
   m_NEXTt=m_NEXTt->next; // dalsi trojuholnik v zozname
  }
 }
	
 // vymazanie zasobnika farieb, hlbky a stencil
 glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);//|GL_STENCIL_BUFFER_BIT);

 // zresetovanie modelovej matice
 glLoadIdentity();

 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glMultMatrixf(m_Camera[0].matrix);

 /*
 // vykreslenie skyboxu
 glPushMatrix();
 glRotatef(180.0f,0.0f,1.0f,0.0f);
 ogl_Objects.obj_skybox_draw();
 glPopMatrix();
 */
	
 // TRANSFORMACIA SCENY PODLA NASTAVENI AKTUALNEJ KAMERY!
 glTranslatef(m_Camera[0].posx,m_Camera[0].posy,m_Camera[0].posz);

 // transformacia polohy svetla
 //ogl_Light[0].pos[0]=-m_Camera[0].posx;
 //ogl_Light[0].pos[1]=-m_Camera[0].posy;
 //ogl_Light[0].pos[2]=-m_Camera[0].posz;
 glLightfv(GL_LIGHT0,GL_POSITION,ogl_Light[0].pos);

 // aktualizacia Frustum
 //ogl_Frustum.FrustumUpdate();

 // vykreslenie objektov sceny - svetlo (kocka)
 glPushMatrix();
 //glTranslatef(ogl_Light[0].pos[0],ogl_Light[0].pos[1],ogl_Light[0].pos[2]);
 //ogl_Objects.obj_cube0(0.1f);
 glPopMatrix();

 // ulozenie aktualnej matice do zasobnika matic
 glPushMatrix();

 // vykreslenie trojuholnikov nacitanych zo zdrojoveho suboru
 ogl_Triangle.triangle_draw();
 
 // vyber aktualnej matice zo zasobnika matic
 glPopMatrix();

 // vykreslenie normal
 if (normals_onoff==1) {
  glPushMatrix();
  ogl_Triangle.DrawNormals(0.25f);
  glPopMatrix();
 }

 // ulozenie aktualnej matice do zasobnika matic
 glPushMatrix();
 /*
 if (ogl_Frustum.PointInFrustum(ogl_Light[0].pos[0]-m_Camera[0].posx,
                                ogl_Light[0].pos[1]-m_Camera[0].posy,
                                ogl_Light[0].pos[2]-m_Camera[0].posz)) {
  ogl_Objects.obj_lensflare(m_Camera[0].posx,m_Camera[0].posy,m_Camera[0].posz,
                            m_Camera[0].targetx,m_Camera[0].targety,m_Camera[0].targetz,
                            m_Camera[0].matrix[1],m_Camera[0].matrix[5],m_Camera[0].matrix[9],
                            m_Camera[0].matrix[0],m_Camera[0].matrix[4],m_Camera[0].matrix[8],
                            ogl_Light[0].pos[0]-m_Camera[0].posx,
                            ogl_Light[0].pos[1]-m_Camera[0].posy,
                            ogl_Light[0].pos[2]-m_Camera[0].posz);
 }
 */
 // vyber aktualnej matice zo zasobnika matic
 glPopMatrix();

 // vykreslenie zameriavacieho kriza - jednoduchej textury
 ogl_Texture.DrawCrosshair(m_Camera[0].scr_w,m_Camera[0].scr_h);

 if (help_onoff) {
  // vypis textu - help
  ogl_Text.OpenDrawString();
  ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
  ogl_Text.SetFontSize(10);

  sprintf(ogl_Text.mybuf,"ESC        ukoncenie aplikacie");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-20.0f);
  sprintf(ogl_Text.mybuf,"MYS        rotacia v danom smere a strelba");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-60.0f);
  sprintf(ogl_Text.mybuf,"SIPKY      posun dopredu,dozadu,vlavo,vpravo");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-80.0f);
  sprintf(ogl_Text.mybuf,"A,Z        posun hore,dole - neplati pre typ pohybu - chodza");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-100.0f);
  sprintf(ogl_Text.mybuf,"J          skok");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-120.0f);
  sprintf(ogl_Text.mybuf,"SHIFT      zrychlenie posunu");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-140.0f);
  sprintf(ogl_Text.mybuf,"Q          obnova udajov zo zdrojoveho suboru");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-160.0f);
  sprintf(ogl_Text.mybuf,"R          reinicializacia pohladu kamery");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-180.0f);
  sprintf(ogl_Text.mybuf,"C          zapnutie/vypnutie detekcie kolizii");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-200.0f);
  sprintf(ogl_Text.mybuf,"M          vyplnene trojuholniky/iba hrany trojuholnikov");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-240.0f);
  sprintf(ogl_Text.mybuf,"L          zapnutie/vypnutie osvetlenia");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-260.0f);
  sprintf(ogl_Text.mybuf,"N          zapnutie/vypnutie zobrazenia normal");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-280.0f);
  sprintf(ogl_Text.mybuf,"G          zapnutie/vypnutie hmly");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-300.0f);
  sprintf(ogl_Text.mybuf,"F          zmena typu hmly");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-320.0f);
  sprintf(ogl_Text.mybuf,"T          zapnutie/vypnutie texturovania");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-340.0f);
  sprintf(ogl_Text.mybuf,"H          zapnutie/vypnutie zobrazenia helpu");
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-360.0f);

  ogl_Text.CloseDrawString();
 }
 else {
  // vypis textu - poloha kamery
  ogl_Text.OpenDrawString();
  ogl_Text.SetTextColor(1.0f,0.8f,0.0f);
  ogl_Text.SetFontSize(10);

  sprintf(ogl_Text.mybuf,"x: %6.2f",-m_Camera[0].posx);
  ogl_Text.DrawString(10.0f,30.0f);
  sprintf(ogl_Text.mybuf,"y: %6.2f",-m_Camera[0].posy);
  ogl_Text.DrawString(10.0f,20.0f);
  sprintf(ogl_Text.mybuf,"z: %6.2f",-m_Camera[0].posz);
  ogl_Text.DrawString(10.0f,10.0f);

  // vypis textu - pocet obrazkov za sekundu
  sprintf(ogl_Text.mybuf,"%i fps",(GLuint) m_Camera[0].ogl_fps);
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-20.0f);

  // pocet nacitanych trojuholnikov
  sprintf(ogl_Text.mybuf,"pocet trojuholnikov: %i",ogl_DataFile.gldata_count);
  ogl_Text.DrawString(10.0f,m_Camera[0].scr_h-40.0f);

  ogl_Text.CloseDrawString();
 }

 return(0);
}

// zmena sposobu zobrazenia objektov ***************************************
void mOGL::change_PolygonMode(void)
{
 glGetIntegerv(GL_POLYGON_MODE,&ogl_State[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_LINE) glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
 else glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);

 SDL_Delay(200);
}

// zap/vyp osvetlenia ******************************************************
void mOGL::change_LightingOnOff(void)
{
 if (glIsEnabled(GL_LIGHTING)) glDisable(GL_LIGHTING);
 else glEnable(GL_LIGHTING);

 SDL_Delay(200);
}

// zap/vyp vykreslovania normal ********************************************
void mOGL::change_NormalsOnOff(void)
{
 if (normals_onoff==0) normals_onoff=1; else normals_onoff=0;

 SDL_Delay(200);
}

// zap/vyp hmly ************************************************************
void mOGL::change_FogOnOff(void)
{
 if (glIsEnabled(GL_FOG)) glDisable(GL_FOG);
 else glEnable(GL_FOG);

 SDL_Delay(200);
}

// zmena parametrov hmly ***************************************************
void mOGL::change_FogMode(void)
{
 glGetIntegerv(GL_FOG_MODE,&ogl_State[0]);

 // INFO: vypis nacitaneho stavu
 //fprintf(stderr,"%d\n",ogl_State[0]);

 if (ogl_State[0]==GL_EXP) glFogi(GL_FOG_MODE,GL_EXP2);
 else if (ogl_State[0]==GL_EXP2) glFogi(GL_FOG_MODE,GL_LINEAR);
      else glFogi(GL_FOG_MODE,GL_EXP);

 SDL_Delay(200);
}

// zap/vyp texturovania ****************************************************
void mOGL::change_TexOnOff(void)
{
 if (glIsEnabled(GL_TEXTURE_2D)) glDisable(GL_TEXTURE_2D);
 else glEnable(GL_TEXTURE_2D);

 SDL_Delay(200);
}

// zap/vyp vypisu helpu ****************************************************
void mOGL::change_HelpOnOff(void)
{
 if (help_onoff==0) help_onoff=1; else help_onoff=0;

 SDL_Delay(200);
}

// nacitanie udajov zo zdrojoveho suboru a priprava zoznamu trojuholnikov **
void mOGL::renew_data(void)
{
 fdata=ogl_DataFile.ReadData(); // pouzije sa funkcia z DataFile
 
 if (fdata!=NULL) {
  // nacitanie textur
  for (t_a=0;t_a<ogl_DataFile.texcount;t_a++) {
   strcpy(fname,"data/material/"); strcat(fname,ogl_DataFile.texname[t_a]);
   if (ogl_Texture.LoadTexture(t_a,fname)) {
    fprintf(stderr,"Chyba nahratia textur! %s\n",fname); //return(1);
   }
  }
  for (t_a=0;t_a<(ogl_DataFile.gldata_count*16);t_a+=16) {
   if (*(fdata+t_a+0)==99) { // kocka
	// ak je tex_id 99, znamena to, ze treba pripravit kocku
	ffx=*(fdata+t_a+1); ffy=*(fdata+t_a+2); ffz=*(fdata+t_a+3);
	fsize=*(fdata+t_a+4);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz+fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz+fsize,
	                          ffx-fsize,ffy+fsize,ffz+fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);
	// dummy - pre vypocet kolizie
	ogl_Triangle.triangle_add(99,
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+2.0f,ffz+fsize,
                              0.0,0.0,1.0,0.0,1.0,1.0,1);
	ogl_Triangle.triangle_add(99,
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+2.0f,ffz+fsize,
	                          ffx-fsize,ffy+2.0f,ffz+fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,1);

    ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx+fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz-fsize,
	                          ffx+fsize,ffy+fsize,ffz+fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);
    // dummy - pre vypocet kolizie
    ogl_Triangle.triangle_add(99,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx+fsize,ffy+2.0f,ffz-fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,1);
	ogl_Triangle.triangle_add(99,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx+fsize,ffy+2.0f,ffz-fsize,
	                          ffx+fsize,ffy+2.0f,ffz+fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,1);

    ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+fsize,ffz-fsize,
	                          ffx+fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);
    // dummy - pre vypocet kolizie
    ogl_Triangle.triangle_add(99,
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+2.0f,ffz-fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,1);
	ogl_Triangle.triangle_add(99,
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+2.0f,ffz-fsize,
	                          ffx+fsize,ffy+2.0f,ffz-fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,1);

    ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx-fsize,ffy+fsize,ffz+fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+fsize,ffz+fsize,
	                          ffx-fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);
    // dummy - pre vypocet kolizie
    ogl_Triangle.triangle_add(99,
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          ffx-fsize,ffy+2.0f,ffz+fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,1);
	ogl_Triangle.triangle_add(99,
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx-fsize,ffy+2.0f,ffz+fsize,
	                          ffx-fsize,ffy+2.0f,ffz-fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,1);

    ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx+fsize,ffy-fsize,ffz-fsize,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy-fsize,ffz-fsize,
	                          ffx+fsize,ffy-fsize,ffz+fsize,
	                          ffx-fsize,ffy-fsize,ffz+fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);

    ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy+fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,0.0,1.0,1.0,0);
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[6],
	                          ffx-fsize,ffy+fsize,ffz+fsize,
	                          ffx+fsize,ffy+fsize,ffz-fsize,
	                          ffx-fsize,ffy+fsize,ffz-fsize,
	                          0.0,0.0,1.0,1.0,0.0,1.0,0);
   }
   else {
	// pridanie trojuholnika nacitaneho zo zdrojoveho suboru
	ogl_Triangle.triangle_add(ogl_Texture.texture_id[(GLuint) *(fdata+t_a+0)],
	                          *(fdata+t_a+1),*(fdata+t_a+2),*(fdata+t_a+3),
	                          *(fdata+t_a+4),*(fdata+t_a+5),*(fdata+t_a+6),
	                          *(fdata+t_a+7),*(fdata+t_a+8),*(fdata+t_a+9),
	                          *(fdata+t_a+10),*(fdata+t_a+11),
	                          *(fdata+t_a+12),*(fdata+t_a+13),
	                          *(fdata+t_a+14),*(fdata+t_a+15),1);
   }
  }
 }
 
 ogl_DataFile.CloseDataFile(); // uvolnenie pamate obsadenej udajmi zo
                               // zdrojoveho suboru
}
